/*
//
// CASE for Alasql.js
// Date: 03.11.2014
// (c) 2014, Andrey Gershun
//
*/

yy.CaseValue = function (params) {
	return Object.assign(this, params);
};
yy.CaseValue.prototype.toString = function () {
	var s = 'CASE ';
	if (this.expression) s += this.expression.toString();
	if (this.whens) {
		s += this.whens
			.map(function (w) {
				return ' WHEN ' + w.when.toString() + ' THEN ' + w.then.toString();
			})
			.join();
	}
	s += ' END';
	return s;
};

yy.CaseValue.prototype.findAggregator = function (query) {
	//	console.log(this.toString());
	if (this.expression && this.expression.findAggregator) this.expression.findAggregator(query);
	if (this.whens && this.whens.length > 0) {
		this.whens.forEach(function (w) {
			if (w.when.findAggregator) w.when.findAggregator(query);
			if (w.then.findAggregator) w.then.findAggregator(query);
		});
	}
	if (this.elses && this.elses.findAggregator) this.elses.findAggregator(query);
};

yy.CaseValue.prototype.toJS = function (context, tableid, defcols) {
	var s = '((function(' + context + ',params,alasql){var y,r;';
	if (this.expression) {
		//			this.expression.toJS(context, tableid)
		s += 'v=' + this.expression.toJS(context, tableid, defcols) + ';';
		s += (this.whens || [])
			.map(function (w) {
				return (
					' if(v==' +
					w.when.toJS(context, tableid, defcols) +
					') {r=' +
					w.then.toJS(context, tableid, defcols) +
					'}'
				);
			})
			.join(' else ');
		if (this.elses) s += ' else {r=' + this.elses.toJS(context, tableid, defcols) + '}';
	} else {
		s += (this.whens || [])
			.map(function (w) {
				return (
					' if(' +
					w.when.toJS(context, tableid, defcols) +
					') {r=' +
					w.then.toJS(context, tableid, defcols) +
					'}'
				);
			})
			.join(' else ');
		if (this.elses) s += ' else {r=' + this.elses.toJS(context, tableid, defcols) + '}';
	}
	// TODO remove bind from CASE
	s += ';return r;}).bind(this))(' + context + ',params,alasql)';

	return s;
};
